<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Article;

class ArticleController extends Controller
{
	function index() {
		return view("articles", ["rows" => Article::all()]);
	}

	function add() {
		return view("add_article_form");
	}

	function view(Article $article) {
		return view("article", [
			"article" => $article
		]);
	}

	function edit(Article $article) {
		return view("edit_article_form", ["article" => $article]);
	}

	function store(Request $request) {
		$request->validate([
			"id" => "nullable|exists:articles",
			"title" => "required",
			"description" => "nullable",
			"content" => "required",
			"status" => "required",
			"publish_at" => "nullable",
			"unpublish_at" => "nullable"
		], [
			"name" => "Публикация должна иметь название.",
			"content" => "Публикация должна иметь текст."
		]);

		$arr = $request;

		$article = Article::find($arr->id) ?? new Article;
		$article->title = $arr->title;
		$article->description = $arr->description ?? explode(".", $arr->content)[0];
		$article->content = $arr->content;
		$article->status = $arr->status;
		$article->publish_at = $arr->publish_at;
		$article->unpublish_at = $arr->unpublish_at;
		$article->save();

		return view("success");
	}

	function drop(Article $article) {
		$article->delete();

		return view("success");
	}
}
